<template>
  <div id="app" class="wrapper">
    <TheHeader />
    <ARegistrationModal v-if="arbaloProfile" />
    <div v-if="message" class="modal" :class="{'is-active': message}">
      <div class="modal-background" v-on:click="close()"></div>
      <div class="modal-content">
        <article class="message" :class="messageCSS(message)">
          <div v-if="message.header" class="message-header">
            <p>{{ message.header }}</p>
          </div>
          <div v-if="message.body" class="message-body">
            <p>{{ message.body }}</p>
          </div>
        </article>
      </div>
      <button class="modal-close is-large" aria-label="close" v-on:click="close()"></button>
    </div>
    <TheSidebar />
    <div v-if="isLoading" class="loading">
      <section class="hero is-fullheight">
        <div class="hero-body">
          <div class="container">
            <div class="columns is-centered">
              <div class="column is-5">
                <progress class="progress is-small is-primary" :value="progress" max="100" />
              </div>
            </div>
          </div>
        </div>
      </section>
    </div>
    <div v-else class="main-content">
      <div v-if="!production" class="notification is-warning">
        <p
          class="has-text-centered has-text-weight-semibold"
        >You are on the Arbalo TEST environment. It is recommended not to use this for production use and instead wait for the PROD deployment at the start of 2020. Thank you.</p>
      </div>
      <router-view />
      <the-call-to-action />
    </div>
    <TheFooter />
  </div>
</template>

<script lang="ts">
import { Component, Vue, Prop } from "vue-property-decorator";
import { Message, MessageLevelCSS, MessageLevel } from "@/store/types";
import TheCallToAction from "@/components/TheCallToAction.vue";
import TheHeader from "@/components/TheHeader.vue";
import TheSidebar from "@/components/TheSidebar.vue";
import TheFooter from "@/components/TheFooter.vue";
import ARegistrationModal from "@/components/ARegistrationModal.vue";

@Component({
  components: {
    TheHeader,
    TheSidebar,
    TheFooter,
    ARegistrationModal,
    TheCallToAction
  }
})
export default class App extends Vue {
  private progress = 0;

  get message() {
    if (this.$store.state.messages) {
      return this.$store.state.messages[0];
    }
  }

  public close() {
    this.$store.commit("shiftMessage");
  }

  get isLoading(): boolean {
    return this.$store.state.loading;
  }

  get arbaloProfile() {
    return this.$store.state.user.arbaloProfile;
  }

  public messageCSS(message: Message): string {
    if (MessageLevelCSS.has(message.level)) {
      return <string>MessageLevelCSS.get(message.level);
    }
    return "";
  }

  get production(): boolean {
    const environment = process.env.VUE_APP_ENVIRONMENT
      ? process.env.VUE_APP_ENVIRONMENT
      : "production";
    switch (environment.toLowerCase()) {
      case "production":
        return true;
      default:
        return false;
    }
  }

  private async mounted() {
    this.$store.commit("setLoading");

    // Things to do if the user is authenticated
    if (this.$keycloak.authenticated) {
      await this.$store.dispatch("user/fetchKeycloakProfile", this.$keycloak);
      this.progress += 10;

      await this.$store.dispatch("user/fetchArbaloProfile", {
        profileUUID: this.$keycloak.tokenParsed!.sub
      });
      this.progress += 20;

      await this.$store.dispatch("fetchProjects");
      this.progress += 20;
    }

    await this.$store.dispatch("catalog/fetchCatalog");
    this.progress += 30;

    if (this.$store.state.activeProject && this.$keycloak.authenticated) {
      this.$store.dispatch("catalog/fetchInstances", {
        projectUUID: this.$store.state.activeProject.uuid
      });
      this.progress += 10;
    }

    this.$store.commit("unsetLoading");
  }
}
</script>

<style lang="scss">
@import "./styles/bulma_arbalo.scss";
@import "./styles/arbalo.scss";

.wrapper {
  display: grid;
  height: 100vh;

  grid-template-columns: $main-content-width;
  grid-template-rows: $navbar-header-height $main-content-height $navbar-bottom-height;
  grid-template-areas:
    "navtop"
    "main-content"
    "footer";

  @include media(">tablet") {
    display: grid;
    height: 100vh;

    grid-template-columns: $navbar-side-width $main-content-width;
    grid-template-rows: $navbar-header-height $main-content-height $navbar-bottom-height;
    grid-template-areas:
      "navside  navtop"
      "navside  main-content"
      "navside  footer";
  }
}

.main-content {
  grid-area: main-content;
  background-color: $background;
}

.message {
  grid-area: main-content;
  z-index: 10;
}
</style>
